// Copyright (c) 2023 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include "UIComponentRenderable.hpp"
#include "display/mesh/QuadMesh.hpp"

namespace Dawn {
  class UIImage : public UIComponentRenderable {
    private:
      Mesh mesh;

    public:
      // @optional
      struct Color color = COLOR_WHITE;
      // @optional
      StateProperty<Texture*> texture;

      UIImage(SceneItem *item);

      float_t getContentWidth() override;
      float_t getContentHeight() override;
      std::vector<struct ShaderPassItem> getUIRenderPasses() override;
      void onStart() override;
  };
}